/*********************************************************************
サンプルアプリ17　Sharp JHシステム　電力見える化

XBee ZBを使ってシャープ社の電力見える化システムJH-RTP2に付属する
タップJH-AP01（スマートプラグ）の情報を受信するソフトウェアです。
同社の専用タブレットを使うことなく消費電力が測れるようになります。

製品の詳細はこちら：
http://www.sharp.co.jp/e_solution/mieruka/products/rtp2_op.html

本ソースリストおよびソフトウェアの目的外の利用は、禁止いたします。
利用を開始した時点で全てを承諾したものといたします。

※ZigBee StackモードZS=2、XBee受信APIのUART設定AO=1で使用します。
　これらは自動で設定します。X-CTUのRestore等で戻すことが出来ます。
　[SHIFT]+[X]キーでプログラムを終了するとXBeeモードに戻ります。
※CTセンサーユニットには対応していません。タップJH-AP01のみです。
　ZigBee End Deviceなので解析困難につき対応予定もありません。
----------------------------------------------------------------------
免責
本アプリにはSharp製品を外部から解析した結果が含まれます。
同社製品のZigBee通信のパケットの解析および、ZigBeeプロトコルに準じた
コマンドにより製品の応答値を解析しました。
一部は総当たりでコマンド等を組み合わせた応答値調査も行っておりますが、
不正な手段や暗号化を解除しての解析などは一切、行っておらず、全て
ZigBee方式のワイヤレス通信による外部解析、すなわち同社製品が公開する
正当なインタフェースを用いて解析した結果であり、権利上の問題は無いと
考えています。
しかし、万が一、同社の権利を侵害していることが判明した場合は速やかに
公開を停止いたします。

同社製品の利用範囲を超えて本ソフトを利用する場合はSharp社からの
承諾を受ける必要があると考えられます。
例えば本ソフトを応用した商品やシステムを販売することが困難な場合が
ありますので、予め同社に確認していただくのが良いでしょう。

★以上に同意いただけない場合は本アプリの利用を認めません。★

謝辞
本アプリの開発にあたり国野亘様から丁寧かつ熱心なご指導を賜りました。
ここに感謝の意を表します。（Tsunekichi Yoshida）

本アプリの著作権はTsunekichi Yoshidaと国野亘の両名が有します。
本ソースリストの著作権表示の改変を禁止します。
利用よりいかなる損害が発生した場合であっても一切の補償を行いません。
権利上の問題などが発生した場合であっても一切の協力を行いません。

                 Copyright (c) 2014 Tsunekichi Yoshida & Wataru KUNINO
                               http://www.geocities.jp/bokunimowakaru/
*********************************************************************/

#define DEVICE_NUM			8
#define TAP_POWER_ADJ		1.00
#define TAP_SUM_ADJ			1.00
// #define DEBUG_AT
#define XBEE_ERROR_TIME
#define FILE_NAME_IEEE		"tap_list.txt"
#define FILE_NAME_TAP		"tap_Ieee_adr.csv"	// 文字数、拡張子長は固定
#define FILE_NAME_HTTP		"examples/htdocs/index.html"
#include "../libs/xbee.c"					// XBeeライブラリ by Wataru
#include "../libs/kbhit.c"					// キーボード入力 by Wataru
#include "../libs/hex2a.c"					// テキスト変換用 by Wataru
#include "../libs/compress_csv.c"			// 要約データ作成 by Wataru
char s[21];									// 文字列の戻り値用 by Wataru

/*-----------------------------------------------------------------------*/
//	以下は各ローカル版・共通版で共通とします。（Wataru）
//	ローカル版の特有な事情は#defineで分けるようにします。（Yoshi）
//	★コメント削除を希望（Yoshi）

/*
　本サンプルアプリSample17_tapを使用するとIEなどのブラウザ上で各タップの
　通信状態、積算電力量、消費電力を表示することが出来ます。
　消費電力は棒グラフと数値[W]と背景色で表示され、背景色は100W以下が緑色、
　100～1000Wの時に黄色、1000Wを超えると赤色になります。
　「冷蔵庫」などのデバイス名をクリックすると今日の1時間ごとの消費電力の
　推移を表示し、「前日」ボタンで昨日以前のデータを表示することが出来ます。
*/

/*
　コンパイルして起動するとペアリングを開始します。シャープ製タップJH-AP01を
　コンセントに挿した状態でペアリングボタンを操作してください。ただし、60秒
　に1度の間隔でペアリングの許可状態を自動で解除しますので、パソコンのCygwin
　コンソール上に「Network Join Disabled」が表示された場合は、コンソール上で
　「j」キーを押下するとペアリングを再開します。
　電力を表示するにはexamples/htdocsフォルダ内のindex.htmlをIEなどのブラウザ
　で開きます。デバイス名を変更するには、「tap_list.txt」をテキストエディタで
　編集してサンプルアプリを再起動します。
　以下はユーザ名が「xbee」の場合の一般的なフォルダ（ディレクトリ）構成とコン
　パイルや実行に必要なファイルです。

	C:\cygwin\home\xbee\Makefile
	C:\cygwin\home\xbee\libs\xbee.c
	C:\cygwin\home\xbee\libs\compress_csv.c
	C:\cygwin\home\xbee\libs\kbhit.c
	C:\cygwin\home\xbee\libs\hex2a.c
	C:\cygwin\home\xbee\examples\sample17_tap.c
	C:\cygwin\home\xbee\examples\htdocs\index.html
	C:\cygwin\home\xbee\examples\htdocs\graph.gif
	C:\cygwin\home\xbee\examples\htdocs\graph_bg.gif
*/

/*
要求仕様（概要）
	・シャープ製タップJH-AP01から消費電力データを取得する機能を有すること。
	・タップは5台以上に対応すること。最大数は暫定8台とする。
	・取得データをテキスト形式で保存する機能を有すること。
		・取得間隔：１分
		・保存情報：取得日時、消費電力[W]
		・管理情報：ZigBeeアドレス、タップの通し番号（１番から）
	・取得データをHTML形式でリアルタイム表示する機能を有すること。
		・表示間隔：1分。但し、目標は20秒間隔とする。
		・表示項目：アドレス、通し番号、消費電力、消費電力グラフ
	・過去データをHTML形式で閲覧する機能を有すること
		・表示間隔：1日単位
		・表示項目：取得日、消費電力の24時間グラフ
	・タップのペアリング機能を有すること
		・ブラウザまたはコンソールからタップのペアリングが実施可能なこと
		・ペアリング許可（ジョイン許可）は自動で非許可に移行すること
	・販売するにあたり、システム商品レベルの品質を確保すること（商品版）
		・3年以上の販売が可能なプラットフォームとすること。
		・3年以上の連続運転が可能である根拠を示すこと。
		・1カ月以上の連続運転を実施し、リリース後3年間は継続運転すること。
		・解析ツールなどの利用により品質を高めること。
		・ソースコードは柔軟かつ簡潔に記述し、機能拡張を容易とすること。
		・開発者がコメントなしで理解できるレベルであること。
		※品質確保は商品版のみの要求仕様です。
*/

/*************************************************************************/

int agreement(void){
	FILE *fp;
	char c;
	
	if( (fp = fopen("./data/sample17_readme.txt","r")) == NULL ){
		if( (fp = fopen("./examples/data/sample17_readme.txt","r")) == NULL ){
			printf("no help files\n");
			return(0);
		}
	}
	while( feof(fp) == 0 ){
		c=getc(fp);
		if( !feof(fp) ) printf("%c",c);
	}
	printf("\n");
	fclose( fp );
	while( kbhit() == 0 );
	c = getchar();
	if( c=='y' || c=='Y' ) return(1);
	else return(0);
}

char *sprintDateStDate(struct tm *time_st){
//	文字列変数sに年月日を代入します。			// by Wataru

/* 履歴 */
//	秀丸エディタが関数と認識してくれません（Yoshi）
//	本当だ。私も秀丸です。（Wataru）

	sprintf(s,"%4d/%02d/%02d",
		time_st->tm_year + 1900,
		time_st->tm_mon + 1,
		time_st->tm_mday
	);
	return s;
}

char *sprintDateStTime(struct tm *time_st){
//	文字列変数sに時分秒を代入します。struct tm入力が必要です。
												// by Wataru
	sprintf(s,"%02d:%02d:%02d",
		time_st->tm_hour,
		time_st->tm_min,
		time_st->tm_sec
	);
	return s;
}

void printDateSt(struct tm *time_st){
//	年月日と時分秒を表示します。struct tm入力が必要です。
//	（struct tm入力が不要なprintDateもあります）
												// by Wataru
												
	printf("%s ",sprintDateStDate(time_st));	// 要分離
	printf("%s ",sprintDateStTime(time_st));	// (戻り値の変数が同じグロバなので)
}

char *sprintDate(void){
//	年月日と時分秒を文字列sに代入します。		// by Wataru
	char str[21];	// ローカル(char sはsprintDateStDate/Timeで使用する)
	time_t timer;
	struct tm *time_st;
	time(&timer);
	time_st = localtime(&timer);
	sprintf(str,"%s",sprintDateStDate(time_st));
	sprintf(str,"%s,%s,",str,sprintDateStTime(time_st));
	sprintf(s,"%s",str);
	return s;
}

void printDate(void){
//	年月日と時分秒を表示します。				// by Wataru
	time_t timer;
	struct tm *time_st;
	time(&timer);
	time_st = localtime(&timer);
	printDateSt(time_st);
}

void htmlOut(
	byte deviceIeee[][8], 
	char deviceName[][9], 
	double *deviceDataSum, 
	double *deviceDataPow, 
	unsigned long *deviceDataTime, 
	int *deviceDataFlag, 
	int numOfDevice
){
//	HTML出力です。htdocsフォルダにindex.htmlを作成します。
												// by Wataru & YoshiYoshi
/* 履歴 */
//	読みにくいので修正しましたがもっと読みにくくなりました。(Yoshi)
//	少し手直ししました。複数のタップでの試験をお願いします。（Wataru）
//	→問題なし。ありがとう。（Yoshi）
//	経過時間から平均電力を求めました。複数タップ試験ください。（Wataru）
//	タップによって継続時間が違うので平均電力は嬉しい機能です。（Yoshi）
//	表を色づけして見やすくしました。(Wataru)
//	少ないソースコードで立体感があるように見えるのが嬉しいです。（Yoshi）
//	複数タップ試験は何台でしていただいたのでしょうか？（Wataru）
//	4台。試験結果はボロボロ。使い物にならない。（Yoshi）
//	1台の試験と4台の試験で異なる不具合が検出されたということでしょうか？
//	また、8台の試験はいつごろ、実施していただく予定でしょうか？（Wataru）
//	台数なんて関係ない。1台でボロボロ。（Yoshi）
//	再々恐れ入ります。1台と4台での違いが知りたいです。（Wataru）
//	4台で問題なく動作しています。不具合は見当たりません。
//	システム販売を断念したので4台に仕様変更してもいいです。（Yoshi）
//	4台の追加購入はしないということでしょうか？（Wataru）
//	無回答につき、XBee ZBモジュールで8台の疑似タップを作成して試験を行い、
//	デバイス登録名の文字化けに関するライブラリ側の不具合を修正しました。
//	（Wataru 2014/8/24）

	FILE *fp_html;
	char filename[] = FILE_NAME_TAP;
	char date[21];
	int i,j;
	int bar;
	
	if((fp_html = fopen(FILE_NAME_HTTP, "w"))){
		fprintf(fp_html, "<head><title>ZigBee Smart Plugs</title>\r\n");
		fprintf(fp_html, "<meta http-equiv=\"refresh\" content=10>\r\n");
		fprintf(fp_html, "<meta http-equiv=\"Content-type\" content=\"text/html; charset=Shift_JIS\">\r\n");
		fprintf(fp_html, "<meta name=\"viewport\" content=\"width=240, initial-scale=1.0, \">\r\n");
		fprintf(fp_html, "</head>\r\n");
		fprintf(fp_html, "<body>\r\n");
		strcpy(date,sprintDate());	// 01234567890123456789
		date[10]=' ';				// 2014/08/14,20:23:30,
		date[16]='\0';				// 2014/08/14 20:23
		fprintf(fp_html, "<center><h3>ZigBee Smart Plugs %s<br>\r\n", date);
		fprintf(fp_html, "</h3><table bgcolor=\"aliceblue\" border=0>\r\n");
		fprintf(fp_html, "<tr><td bgcolor=\"lightgrey\" align=\"center\">デバイス</td><td bgcolor=\"lightgrey\" align=\"center\">状態</td>");
		fprintf(fp_html, "<td bgcolor=\"lightgrey\" align=\"center\">積算電力量</td><td bgcolor=\"lightgrey\" align=\"center\">消費電力</td>\r\n");
		for(i = 0; i < numOfDevice; i++){
			for(j=0;j<4;j++) hex2a( deviceIeee[i][j+4], &(filename[4+j*2]) );
			filename[4+8]='.';
			fprintf(fp_html, "<tr><td bgcolor=\"lavender\"><a href=\"%s.html\">%s</a></td>\r\n", filename, deviceName[i]);
			if(deviceDataFlag[i] >= 0){
				if(deviceDataFlag[i])	fprintf(fp_html, "<td rowspan=2 bgcolor=\"lightgreen\" align=\"center\">○</td>\r\n");
				else 					fprintf(fp_html, "<td rowspan=2 bgcolor=\"lightyellow\" align=\"center\">－</td>\r\n");
				fprintf(fp_html, "<td bgcolor=\"lavender\" align=\"center\">%.0f [kWh]</td>\r\n", deviceDataSum[i]/1000);
				if( deviceDataPow[i] > 1000 ) bar = 101; else bar = (int)(deviceDataPow[i] / 10 + 1);
				fprintf(fp_html, "<td bgcolor=\"lavender\"><img src=\"graph.gif\" height=12 width=%d><br><img src=\"graph_bg.gif\"></td>",bar);
				filename[4+8]='\0';
				fprintf(fp_html, "<tr><td>%s</td>\r\n", &filename[4]);
				fprintf(fp_html, "<td align=\"center\">( %.0f [W] )</td>\r\n",deviceDataSum[i]/(double)deviceDataTime[i]*3600.);
				if(bar<10)		fprintf(fp_html, "<td bgcolor=\"honeydew\" align=\"center\">");
				else if(bar<100)fprintf(fp_html, "<td bgcolor=\"lightyellow\" align=\"center\">");
				else 			fprintf(fp_html, "<td bgcolor=\"pink\" align=\"center\">");
				fprintf(fp_html, "%4.0f [W]</td>\r\n",deviceDataPow[i]);
			}else{
				fprintf(fp_html, "<td rowspan=2 bgcolor=\"pink\" align=\"center\">×</td>\r\n");
				fprintf(fp_html, "<td rowspan=2 colspan=2 align=\"center\" bgcolor=\"pink\">受信中</td>\r\n");
				filename[4+8]='\0';
				fprintf(fp_html, "<tr><td>%s</td>\r\n", &filename[4]);
			}
		}
		fprintf(fp_html, "</table></center><br>\r\n");
		fprintf(fp_html, "</body></html>\r\n");
		fclose(fp_html);
	}
}

byte local_at(char *at){
//	ローカルATコマンドを送信します。			// by Wataru

/* 履歴 */
//	解析用にXBeeへのコマンドを表示する関数local_atとremote_atを追加しました。（Wataru）
//	解析用のスタブをxbee_testに移行しました。詳細はdiffしてください。(Wataru)
//	確認しました。無駄なコメントも削除しました。500行くらいになりそうです。(Yoshi)

	byte ret=0;
	char s[40];
	
	ret=xbee_at(at);
	sprintf(s,"local_at  %s ret",at);
	#ifdef DEBUG_AT
		xbee_log(3,s,ret);
	#endif
	return(ret);
}

byte remote_at(byte *dev,char *at){
//	リモートATコマンドを送信します。			// by Wataru

	byte ret=0;
	char s[48];
	
	ret=xbee_rat(dev,at);
	sprintf(s,"rat %02X%02X%02X%02X %s ",dev[4],dev[5],dev[6],dev[7],at);
	#ifdef DEBUG_AT
		xbee_log(3,s,ret);
	#endif
	return(ret);
}

void initXBeePort(int xbeeSerialPortNum){
//	XBeeポートの初期化を実行します。			// by YoshiYoshi
//	ZigBee PROモードを設定します。（Wataru）

/* 履歴 */
//	ATWRのあとに待ち時間を設けました。（Yoshi）
//	この間もパケットを受けれるようにxbee_delayに変更しました。（Wataru）
//	※このATWRは本当に必要？ 毎回、通るので書き込まなくても。。。（Wataru）
//	Z-Stackモード変更をするとネットワークリセットかかるので必要。(Yoshi)
//	起動の度にフラッシュ書込みが発生しますが、やむを得ないと思います。（Wataru）
//	補足：ATWRで書き込んでおかないと次回の起動時にネットワークがリセットされ
//	　　　PAN IDが変わってしまいます。これを避けるための対策です。（Wataru）

	printDate();
	printf("Initialize XBee Port %d\n",xbeeSerialPortNum);
	xbee_init(xbeeSerialPortNum);
	xbee_atnj(0);
	local_at("ATAO01");
	local_at("ATZS02");
	local_at("ATWR");
	xbee_delay(3000);
}

void xbeeMode(void){
// ZigBee PROモードからXBeeモードに戻します。（Wataru）
	local_at("ATAO00");
	local_at("ATZS00");
	local_at("ATWR");
	xbee_delay(3000);
}

int readIeee(byte deviceIeee[][8],char deviceName[][9]){
//	デバイスのIEEEアドレスのリストファイルを読み込みます。
												// by Yoshi and Wataru
/* 履歴 */
//	デバイスのユーザ名8バイト文字に対応します。（Wataru）
//	8バイト了解です。冷蔵庫、エアコン、テレビ、食洗機、食器乾燥機
//	fgetsだとEOF検出が甘いのでfscanfに戻しました。(Yoshi)
//	ありがとうございます。ボクも気づきました。危険ですね。（Wataru）
//	こういう文字制限はやめてほしい。前にも書いた。コメント消すな。（Yoshi）
//	直ぐ上に「8バイト了解です」とYoshi様に書いていただいています。（Wataru）

	FILE *fp;
	unsigned int dev[8];
	
	printDate();
	printf("Read IEEE Table\n");
	if( (fp = fopen(FILE_NAME_IEEE, "r")) ){
		int i,j;
		for(j = 0; j < DEVICE_NUM; j++){
			if( fscanf(
				fp, "%02X%02X%02X%02X %02X%02X%02X%02X ", 
				&dev[0],&dev[1],&dev[2],&dev[3],
				&dev[4],&dev[5],&dev[6],&dev[7]
			) == EOF ){
				break;
			}
			fgets(s,sizeof(s),fp);
			deviceName[j][8] = '\0';
			for(i = 0; i < 8; i++){
				if( s[i] == '\n' || s[i] == '\r' ){
					deviceName[j][i] = '\0';
					break;
				}
				deviceName[j][i] = s[i];
				if( s[i] == '\0' ) break;
			}
			printf("device %d = ",j + 1);
			for(i = 0; i < 4; i++){
				deviceIeee[j][i]=(byte)dev[i];
				printf("%02X",deviceIeee[j][i]);
			}
			printf(" ");
			for(i = 4; i < 8; i++){
				deviceIeee[j][i]=(byte)dev[i];
				printf("%02X",deviceIeee[j][i]);
			}
			printf(" (%s)\n",deviceName[j]);
		}
		fclose(fp);
		printf("Total %d devices\n",j);
		return j;
	}else{
		fprintf(stderr,"ERROR:Failed Fopen %s\n",FILE_NAME_IEEE);
		return -1;
	}
}

int saveTapData(byte *dev, double Sum, double Pow, unsigned long Time){
//	タップのデータをファイルに保存します。
//	日付,時刻,電力,積算量,経過時間				// by Yoshi and Wataru
												
/* 履歴 */
//	libs内のcompressに通せるように修正してます。（Wataru）
//	compressの都合で書式を変更しました。仕様は上記のとおりにします。(Wataru)
//	経過時間Timeは必要？（Yoshi）
//	ここで書いた値は使っていませんが、平均電力が簡単になります。（Wataru）
//	その機能は重宝してる。でもデータの期間から計算できるから不要（Yoshi）
//	プラグを抜いたとき（積算値がゼロになったところ）を検索して、
//	そこからの経過時間を計算するということでしょうか？（Wataru）
//	必須では無い。必要性は理解した。残してYoshi。（Yoshi）

	char filename[] = FILE_NAME_TAP;			//	"NameIeee_adr.csv"
	char date[21];
	int i;
	FILE *fp;
	
	strcpy(date,sprintDate());	// 01234567890123456789
	date[16]='\0';				// 2014/08/14,20:23
	
	for(i=0;i<4;i++) hex2a( dev[i+4], &(filename[4+i*2]) );
	if( (fp = fopen( filename, "a")) ) {
		fprintf(fp, "%s, %.0f, %.0f, %lu\n",date,Pow,Sum,Time);	// %lu = ul書式
		fclose(fp);
		return 0;
	}else{
		fprintf(stderr,"Failed fopen %s\n",filename);
		return -1;
	}
}

int compressData(char *dateStringBuffer, byte deviceIeee[][8], int numOfDevice){
//	取得データ（ファイル）から指定日１日分の１時間ごとの電力の平均値を計算し、
//	HTMLコンテンツとCSVを作成します。
//	※積算消費量や経過時間は集計しません。		// Wataru

/* 履歴 */
//	結合試験：
//	compressが不具合多数です。セグフォールトの危険もあります。
//	ファイル名(8文字までなのに12文字)、変数ymdはlongにしてください。
//	あと、作成したCSVとHTMLデータを作り直したい。(Yoshi)
//	ありがとうございます修正しました。（Wataru）
//	システム試験：
//	compressバグだらけ。8月末リリースは無理。作り直した方が良い。(Yoshi)
//	すみません。このモジュールはほとんど評価していませんでした。
//	不具合箇所を教えてください。地道に直します。（Wataru）
//	compressはライブラリのつもり？品質、汎用性、全然だめ。
//	XBeeライブラリとの大差は何？ 原作者？ なぜにPC専用なのに自炊コード？
//	明日までに私が直します。もう触わらなくてYOSHI。★コメント削除（Yoshi）
//	運用を始めてから短期間のうちにアプリが長時間、止まっていた場合などに
//	HTMLコンテンツが正しく作成できない不具合を改善するためにcompressDataAllを
//	追加いたしました。（Wataru）
//	失礼なことを書いてしまいました。撤回させてください。★コメント削除をお願いします。
//	新しいモジュールを作成しかけたのですが、国野様の対策処理の内容をようやく
//	理解し始めました。結局のところ、同じような処理が必要と思います。そこで、
//	データをCSVではなくデータベースに保存すれば、拾い物の組み合わせで作成でき、
//	品質も安定すると思いました。2週間ほどいただけないですか？（Yoshi）
//	拾い物とはネット上からかき集めたソースと言う意味だと思いますが、
//	拾う場合、権利の調整もお願いできるでしょうか？（Wataru）
//	無回答につき、不具合を地道に直すことも並行して進めておきます。（Wataru）

	int i,index;
	char filename[] = FILE_NAME_TAP;			//	"NameIeee_adr.csv"
	
	printDate();
	for(index = 0; index < numOfDevice; index++){
		for(i = 0; i < 4; i++) hex2a(deviceIeee[index][i+4], &(filename[4+i*2]));
		printf("Compress Data %s %s\n",dateStringBuffer,filename);
		compress_data(dateStringBuffer, filename, WATT ,NA ,NA);
	}
	return 0;
}

int compressDataAll(byte deviceIeee[][8], int numOfDevice){
//	全取得データ（ファイル）から１時間ごとの電力の平均値を計算し、
//	HTMLコンテンツとCSVを作成します。
//	元ファイルは不要になってから手動で消してください。
//	※毎日の計算が止まってしまったときなどにHTMLとCSVを修復します。
//	※期間が長いと処理時間がかかります。
//	※積算消費量や経過時間は集計しません。		// Wataru

/* 履歴 */
//	アプリが長期間、止まっていた場合にHTMLコンテンツが正しく
//	作成できない時に呼び出します。mainでは「Shift」+「C」で呼び出します。（Wataru）
//	なにそれ？ まだ使うつもり？ 明日までに作るから、触らないでいい。★コメント削除希望（Yoshi）
//	めったに発生しないので、発生した時の修復用です。（Wataru）
//	失礼なことを書いてしまいました。★コメント削除を希望します（Yoshi）
//	不具合は地道に直す方向で進めています。（Wataru）

	int i,index;
	char filename[] = FILE_NAME_TAP;			//	"NameIeee_adr.csv"
	
	printDate();
	for(index = 0; index < numOfDevice; index++){
		for(i = 0; i < 4; i++) hex2a(deviceIeee[index][i+4], &(filename[4+i*2]));
		printf("Compress Data All %s\n",filename);
		compress_data("2000/01/01", filename, WATT ,NA ,NA);
	}
	return 0;
}

void paringJoinEnable(){
//	ペアリング用にJoin許可を行います。		// by Yoshi

/* 履歴 */
//	xbee_atnjを10秒未満にすると待ち受けませんので、9秒に変更しました。（Wataru）
//	仮にxbee_atzsを作ったら、きっとatnjの二の舞いです。（Yoshi）
//	生まれても幸せにならないので断念します。（Wataru）
//	タップを初期化すると9秒では成功しません。永久許可にして定期的に解除します。（Yoshi）
//	xbee_atnjの第1引数の意味が一貫しない。
//	入力パラメータを増やして仕様を改善してほしい。★削除（Yoshi）
//	現行のXBeeライブラリ仕様につき、変更いたしません。（Wataru）

	printDate();
	printf("Network Join Enabled\n");
	xbee_atnj(0xFF);
}

void paringJoinDisable(){
//	ペアリング用のJoin許可を拒否します。（Yoshi）
//	入力パラメータを増やして仕様を改善してほしい。★削除（Yoshi）
//	現行のXBeeライブラリ仕様につき、変更いたしません。（Wataru）

	printDate();
	printf("Network Join Disabled\n");
	xbee_atnj(0x00);
}

int indexZdoDevice(byte *dev, byte deviceIeee[][8], int numOfDevice){
//	タップのアドレスをIEEEリストから探します。	// by Yoshi and Wataru

/* 履歴 */
//	bytecmpを使わせてもらいます。（Yoshi）
//	↑strncmpを使えと言う意味。自炊バカ？勉強不足？（Yoshi）
//	ありがとうございます。置き換えていただいて結構です。（Wataru）

	int index;

	for(index = 0; index < numOfDevice; index++){
		if(bytecmp(deviceIeee[index], dev, 8) == 0){
			break;
		}
	}
	if(index == numOfDevice) index = -1;
	return index;
}

int paringZdoDevice(byte *dev, byte deviceIeee[][8], int numOfDevice){
//	タップとのペアリングを行います。IEEEリストになかったらリストに追加します。
												// by Yoshi and Wataru

/* 履歴 */
//	デバイスのユーザ名8バイト文字に対応しました。（Wataru）
//	現状で進めます。（Wataru）

	int index;
	
	index = indexZdoDevice(dev, deviceIeee, numOfDevice);

	if(index < 0 ){	// リストに見つからなかったら追加；
		printDate();
		printf("New Device Found\n");
		FILE *fp;
		if( numOfDevice < DEVICE_NUM ){
			if( (fp = fopen(FILE_NAME_IEEE, "a")) ){
				int i;
				fprintf(fp,"%02X%02X%02X%02X %02X%02X%02X%02X unknown%1X\n", 
						dev[0],dev[1],dev[2],dev[3],
						dev[4],dev[5],dev[6],dev[7],
						numOfDevice + 1
				);
				fclose(fp);
				index = numOfDevice;
				numOfDevice++;
				for(i = 0;i < 8; i++){
					deviceIeee[index][i]=dev[i];
				}
			}
		}else{
			fprintf(stderr,"ERROR:List is Full (Total=%d)\n",DEVICE_NUM);
		}
	}
	printDate();
	printf("Pairng: Index Number = %d. (Total %d)\n",index + 1,numOfDevice);
	return index;
}

int sendReadPower(byte *dev){
//	タップから消費電力[W]を取得します。			// by YoshiYoshi

/* 履歴 */
//	４バイトリトルエンディアン。Seq=11
//	ショートアドレス固定でも動くことを確認しました。この方が綺麗です。（Yoshi→Wataru）
//	誤った情報でご迷惑をおかけしました。確かにショートだけでも動作しました。(Wataru)
//	Seqは固定値でもよろしいでしょうか(Yoshi)
//	相手がRouterなので問題ないです。(Wataru)

	byte shortAddress[] = {0xFF,0xFE};		// ショートアドレスはXBee側で検索して設定
	xbee_short_address(shortAddress);
	return (int)remote_at(dev,"ZC1414FD0C010400000011000040");
}

int sendReadPowerSummation(byte *dev){
//	タップから消費電力量[Wh]を取得します。		// by YoshiYoshi

/* 履歴 */
//	６バイトリトルエンディアン。Seq=22

	byte shortAddress[] = {0xFF,0xFE};		// ショートアドレスはXBee側で検索して設定
	xbee_short_address(shortAddress);
	return (int)remote_at(dev,"ZC1414FD0C010400000022000140");
}

int sendReadSummationTime(byte *dev){
//	タップから測定継続時間[Sec]を取得します。	// by YoshiYoshi

/* 履歴 */
//４バイトリトルエンディアン。。Seq=33

	byte shortAddress[] = {0xFF,0xFE};
	xbee_short_address(shortAddress);
	return (int)remote_at(dev,"ZC1414FD0C010400000033000240");
}

int sendReadPowerTemprature(byte *dev){
//	タップから何かの情報を取得します。
												// by YoshiYoshi
/* 履歴 */
//	タップから（たぶん）温度を取得する命令だが「使い物にならない」。Seq=44
//	変換方法は調査中。係数が不明。(Yoshi)
//	Aplの7バイト目が0x39なので受信処理をFloat型に変更。温度では無い（Wataru）
//	0～3599を巡回していますので何らかの補正値だと思います。（Yoshi）
//	そのようです。数か所しか確認はしていませんが、3600に近づいた後に
//	積算値がインクリメントしていましたので、積算値の微小値と思いますが
//	1/3600という中途半端さが不明なのと、時間もないので、今回は使わない
//	ことにします。（Wataru）
//	関数名のTempratureは残しておきますが温度説は皆無と思います。（Wataru）

	byte shortAddress[] = {0xFF,0xFE};
	xbee_short_address(shortAddress);
	return (int)remote_at(dev,"ZC1414FD0C010400000044000340");
}

int getZclEndpointSource(byte *zcl){			// by YoshiYoshi
	return (int)zcl[0];
}
int getZclEndpointDestination(byte *zcl){		// by YoshiYoshi
	return (int)zcl[1];
}
unsigned int getZclCluster(byte *zcl){			// by YoshiYoshi
	return (unsigned int)zcl[2] * 256 + (unsigned int)zcl[3];
}
unsigned int getZclProfile(byte *zcl){			// by YoshiYoshi
	return (unsigned int)zcl[4] * 256 + (unsigned int)zcl[5];
}

int checkZclCmp(byte *zcl, int se, int de, unsigned int ci, unsigned int pi){
//	ZCLヘッダの一致を確認します。				// by YoshiYoshi
//	strcmpやbytecmpに合わせるため、一致したときに0を応答します。
								
	if(
		getZclEndpointSource(zcl) == se &&
		getZclEndpointDestination(zcl) == de &&
		getZclCluster(zcl) == ci &&
		getZclProfile(zcl) == pi
	){
		return 0;
	}else{
		return -1;
	}
}

void print_packet(const byte i){				// by Wataru
	switch( i){
		case 0x01:	printf("Packet Acknowledged\n");	break;
		case 0x02:	printf("Packet was a broadcast packet\n");	break;
		case 0x20:	printf("Packet encrypted with APS encryption\n");	break;
		case 0x21:	printf("Encrypted Acknowledged packet\n");	break;
		case 0x22:	printf("Encrypted broadcast packet\n");	break;
		case 0x41:	printf("Acknowledged from an end device\n");	break;
		case 0x42:	printf("Broadcast from an end device\n");	break;
		case 0x60:	printf("Encrypted from an end device\n");	break;
		case 0x61:	printf("Encrypted Ack from an end device\n");	break;
		case 0x62:	printf("Encrypted Broadcast from end device\n");	break;
		default: printf("Recieved Unknown Packet\n"); break;
	}
}

void printUartParm(byte *from, byte *shortadr, byte *zcl, byte status, byte *data, byte len){
												// by Wataru & Yoshi
	byte i;
	printf("\n--------------------\nrecieved UAR2 AO=1\n--------------------\n");
	printf("from   :");
	for(i=0;i<4;i++) lcd_disp_hex( from[i] ); lcd_putch( ' ' );
	for(i=4;i<8;i++) lcd_disp_hex( from[i] ); lcd_putch( ' ' );
	for(i=0;i<2;i++) lcd_disp_hex( shortadr[i] ); lcd_putch( '\n' );
	printf(
		"endpt  :%02X to %02X\n", getZclEndpointSource(zcl),
		getZclEndpointDestination(zcl)
	);
	printf("Cluster:%04X\n", getZclCluster(zcl));
	printf("Profile:%04X\n", getZclProfile(zcl));
	printf("status :%02X ", status);
	print_packet(status);
	printf("data   :");
	for(i=0;i<len;i++){
		printf("%02X ",data[i] );
	}
	lcd_putch( '\n' );
}

void printUAR2(XBEE_RESULT *xbee_result, byte len){
	printUartParm(
		xbee_result->FROM, 
		xbee_result->SHORT, 
		xbee_result->ZCL, 
		xbee_result->STATUS, 
		xbee_result->DATA,
		len
	);
}

void printMODE_MODM(byte status){				// by Wataru
	printf("\n--------------------\nrecieved MODEM Status\n--------------------\n");
	printf("status :%02X ", status);
	switch( status ){
		case 0x00:	printf("Hardware Reset\n");	break;
		case 0x01:	printf("Watchdog timer reset\n");	break;
		case 0x02:	printf("Joined network\n");	break;
		case 0x03:	printf("Disassociated\n");	break;
		case 0x06:	printf("Coordicator started\n");	break;
		default: printf("Unknown\n"); break;
	}
}

void printUNKNOWN(byte mode,byte status){		// by Wataru
	printf("\n--------------------\nrecieved UNKNOWN\n--------------------\n");
	printf("mode   :%02X\n", mode );
	printf("status :%02X ", status);
	print_packet(status);
}

void printUiHelp(void){							// by Wataru
	printf("Help Command\n");
	printf("        [J]:Enable to Join Net\n");
	printf("        [P]:Get Measured Power\n");
	printf("        [S]:Get Power Summation\n");
	printf("        [T]:Get Elapsed Time\n");
	printf("        [O]:Get Tempratue\n");
	printf("        [F]:Reset Triger's Flags\n");
	printf("        [C]:Calculate Count\n");
	printf("[Shift]+[C]:Calculate the all Count\n");
	printf("[Shift]+[Q]:Quit\n");
	printf("[Shift]+[Z]:Quit\n");
	printf("[Shift]+[X]:Restore XBee mode, Quit\n");
}

double zbByteUint(byte *data, int len){			// by Yoshi lenバイト整数データをdoubleに変換
//	ZigBeeのバイト単位リトルエンディアンの整数データをdoubleに変換
//	引数LENに変換するバイト数を入れる。

/* 履歴 */
//	longにしたほうが良いのでは？（Wataru）
//	アナログデータをdoubleで統一したいと思います。（Yoshi）→了解（Wataru）
//	zbByteULを追加しました。当て付けじゃないです。経過時間がきっとunsinged longだからです。（Wataru）
//	小生に同調してもらっていてありがたいです。★削除（Yoshi）
//	前言撤回。独りよがりで譲ってくれない。★削除（Yoshi）

	double out = 0.;
	int i;
	
	for(i = len - 1; i >= 0; i--){
		out *= 256.;
		out += (double)data[i];
	}
	return out;
}

unsigned long zbByteUL(byte *data, int len){	// by Wataru lenバイト整数データをulに変換
	unsigned long out = 0.;
	int i;
	
	for(i = len - 1; i >= 0; i--){
		out *= 256;
		out += (unsigned long)data[i];
	}
	return out;
}


double zbByteFloat(byte *data){				// by Yoshi 4バイト少数データをdoubleに変換
//	ZigBeeのバイト単位リトルエンディアンの浮動小数データをdoubleに変換

/* 履歴 */
//	こちらもfloatせずにdoubleで統一しています。（Yoshi）

	double out = 0.;
	int exp;
	int i;
	
	out = ((double)data[0]) / 256.;
	out += (double)data[1];
	out /= 256.;
	out += (double)(data[2] & 0x7F);
	out /= 128.;
	out += 1.;
	
	exp = (data[3] & 0x7F) * 2;
	exp += (data[2] >> 7);
	exp -= 127;
	
	for(i = 0; i < exp; i++) out *= 2.;
	for(i = 0; i > exp; i--) out /= 2.;
	return out;
}

int main(int argc,char **argv){
//	初期化処理の後にLOOP処理を行います。
//	LOOP処理中はタイマーによる定期処理、受信処理、ユーザ入力処理を順に行います。
												// by Wataru & YoshiYoshi
/* 履歴 */
//	> >> (略)xbee_testでは正しく応答するのに応答しません。
//	> >> ペアリングボタンを使ったZDO（エンドポイント00h）は応答します。
//	> >> 00h以外は受けれないようです。
//	> >> ソースコードを添付しましたので、教えていただけないでしょうか。
//	> ZigBee PROモードではIEEEアドレス指定では無くショート
//	> アドレス指定で送信する必要があります。←後日、IEEEでも動作することが判明。
//	> またzbSendPack関数内に複数のバグがありましたので書き
//	> 換えました。（実物で動作するかどうかは分かりません。）
//	動きました。とても素晴らしいです。どうも、ありがとうございました。（Yoshi）
//	ユーザコマンドはxbee_testほど多くないのでキーボードの1キーコマンドにします。(Wataru)
//	「H」をタイプするとヘルプ表示です。←亘様、エッチは欠番です。（Yoshi）
//	欠番が分かるように未使用コマンドと使用済みコマンドを区別した表を作成しました。（Wataru）
//	処理の順序を変えました（ユーザ入力を後ろに）。diffが分かりにくくなります。（Wataru）
//	このところ未使用コマンドのメンテができていませんでした。消したコマンドを未使用に戻しました。（Yoshi）
//	リリースまでにmain関数の動きが分かるようなコメントの充実をお願いします。（Wataru）
//	あのー。始めはコメントなしでも分かるようなコードだったのを分からなくしたのは誰ですか？（Yoshi）
//	その方針を維持して進める担当はYoshi様と言うことになっていました。（Wataru）
//	mainのコメント付与はしない。ソースは非公開にする。公開したら提訴する。
//	このソフトの権利は全て私にあるので、即刻、全データを削除せよ。（Yoshi）
//	合意できません。詳細は別記のとおりです。（Wataru）
//	公開は良し。勝手にしたらいい。＜略＞
//	「メールで送っていただいたソースコードの権利は」と限定付なので公開できるのは
//	このファイルだけ。＜略＞
//	これで終わりにする。あなたの対応や人間性、情報管理には問題ある。
//	メールやテキストファイルの公開は一切禁止。読んだら、すぐに削除せよ。（Yoshi）

//	上記のコメントの一部の情報（一般公開するにあたり不適切表現、無関係な表現、
//	個人を特定する情報など）を削除しました。また誤字も修正しました。
//	（Wataru 2014/8/24）

/*
重要事項の追記（国野亘）：
元々共同開発者はシステム販売を考えておりました。しかしタップの調達などの事情によ
り困難となったためソフト単体を販売したいとのことで、サイトへの公開を中止する要望
と、本ソフトは単独で開発したものであり国野亘には一切の権利が無いとの連絡を2014年
8月20日に受けました。それぞれの合意を得た過去メールを添付して反論したところ、暗
号化ZIPにテキストが添付された一転した内容の返信がありました。その内容は、公開と
配布の容認(謝罪は無し)、過去メールを添付した行為が情報の取扱不備であるとの指摘、
過去のメール送付物は全て消去してほしいとの要望、当方(国野亘)のアカウントが乗っ取
られているとの指摘、複雑なパスワードへの変更のアドバイス、今後は全て暗号ZIPでメ
ール交換するとの宣言および依頼、連絡用の新しいパスワードの連絡でした。8月23日に
暗号化・パスワード以外については合意できない旨を返信しましたが、メールの宛先不明
で戻ってくるようになり伝わりませんでした。

9月4日に解決しました。また以下の謝罪文（謝罪の文言は無いがタイトルに「お詫び」の
文字あり）と、ソフトやドキュメントの公開の許可をいただきました。（メール除く）
許せない部分も多々ありますが命がけで進めようとしていた企画の挫折が発端と聞いて、
多少の理解はすることにいたしました。

						謝辞とお詫び
						本企画にご賛同いただいた皆様並びに
						丁寧かつ熱心なご指導を賜りました
						国野亘様に心より感謝申し上げます。
						誠に勝手ながら本企画の起案者である
						Yoshi Yoshiの都合により計画を中止
						することにいたしました。
						ソフトウェア等の著作物を公開・配布する
						全権利を共同開発者である国野様に
						委ねますのでご活用ください。
						2014年9月3日 Yoshi Yoshi

一方、メールの不通は住居が無くなったから、傲慢な態度はシャープから圧力がかかった
ので迷惑がかからないようあえて冷たくしたなど、作り話にしか思えない内容が書かれて
いたあげく、そのメールに返信しても宛先不明で、こちらの意見は一行に伝わりません。
このような状況で完全に許すことは出来ません。

一般公開するにあたり意味不明な表現、不適切な表現、個人を特定する情報などを国野亘
が削除・修正しました。一文の全体を書き直している場合もあります。

Yoshi Yoshi 様

貴方が歩み寄ってくれた分は本ソースの一部のコメント削除分です。
その量はDIFFで判断してください。
公開・配布は初めからの約束ですので、お詫びで権利を委ねるようなことをいわれても、
こちらとしては元々得られるはずだったもので、何も追加で得たものはありません。
*/

	int i;
	int index;	
	int mainLoopFlag = 1;
	XBEE_RESULT xbee_result;
	byte xbeeSerialPortNum;
	time_t timer;
	struct tm *time_st;
	int trigerTimeInMinutes = -1;
	int trigerTimeInSeconds = -1;
	int numOfDevice;
	int xbeeRxData;
	int joinEnable = 0;
	char keyboardCommand;
	
	byte deviceIeee[DEVICE_NUM][8];
	char deviceName[DEVICE_NUM][9];
	double deviceDataSum[DEVICE_NUM];
	double deviceDataPow[DEVICE_NUM];
	unsigned long deviceDataTime[DEVICE_NUM];
	int deviceDataFlag[DEVICE_NUM];		// -1以下:no device, 0:found, 1:data available

	const byte zbBroadIeee[] ={0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF};

	const byte zbAplHeaderPow[] ={0x18,0x11,0x01,0x00,0x40,0x00,0x39};	// 消費電力
	const byte zbAplHeaderSum[] ={0x18,0x22,0x01,0x01,0x40,0x00,0x25};	// 消費電力量
	const byte zbAplHeaderTime[]={0x18,0x33,0x01,0x02,0x40,0x00,0x23};	// 測定時間
	const byte zbAplHeaderTemp[]={0x18,0x44,0x01,0x03,0x40,0x00,0x39};	// 温度ではありませんでした。
	
	char dateStringBuffer[11] = "2099/01/01";
	
	if( agreement()==0 ) exit(0);
	
	// 初期化処理
	for(index = 0; index < DEVICE_NUM; index++){
		deviceDataSum[index] = -1.;
		deviceDataPow[index] = 0.;
		deviceDataTime[index] = 0;
		deviceDataFlag[index] = -1;
		sprintf(deviceName[index],"TAP_%d",index + 1);
	}
	if(argc == 2){
		xbeeSerialPortNum = atoi(argv[1]);
	}else{
		xbeeSerialPortNum = 0;
	}
	initXBeePort(xbeeSerialPortNum);
	numOfDevice = readIeee(deviceIeee,deviceName);
	if(numOfDevice < 0){
		numOfDevice = 0;
		paringJoinEnable();
		joinEnable = 1;
	}
	
	// メイン処理
	printDate();
	printf("Started XBee %02d\n",xbee_atai());
	while(mainLoopFlag){
		/* タイマー処理・電力取得指示 */
		time(&timer);
		time_st = localtime(&timer);
		if(time_st->tm_min != trigerTimeInMinutes){		// 1分に1回
			if(time_st->tm_min == 0){					// 正時の処理
				compressData(dateStringBuffer, deviceIeee, numOfDevice);
			}
			trigerTimeInMinutes = time_st->tm_min;
			printDateSt(time_st);
			printf("Get PowSum for %d Taps\n",numOfDevice);
			for(index = 0; index < numOfDevice; index++){
				if( deviceDataFlag[index] < 0 ){
					if(deviceDataFlag[index] > -60 ) deviceDataFlag[index]--;
				}else{
					deviceDataFlag[index] = -1;
				}
				sendReadPowerSummation(deviceIeee[index]);
			}
			if(joinEnable == 1){
				paringJoinDisable();
				joinEnable = 0;
			}
		}
		if( time_st->tm_sec != trigerTimeInSeconds){	// 1秒に1回
			trigerTimeInSeconds = time_st->tm_sec;
			if( trigerTimeInSeconds % 20 == 5 ){		// うち20秒に1回
				printDateSt(time_st);
				printf("Get Power for %d Taps\n",numOfDevice);
				for(index = 0; index < numOfDevice; index++){
					sendReadPower(deviceIeee[index]);
				}
			}
			if( trigerTimeInSeconds == 55 ){
				printDateSt(time_st);
				printf("Get Power for %d Taps\n",numOfDevice);
				for(index = 0; index < numOfDevice; index++){
					sendReadSummationTime(deviceIeee[index]);
				}
			}
			if( trigerTimeInSeconds % 20 == 10 ){
				htmlOut(deviceIeee,deviceName,deviceDataSum,deviceDataPow,deviceDataTime,deviceDataFlag,numOfDevice);
			}
		}
		strcpy(dateStringBuffer, sprintDateStDate(time_st));
	
		/* ZigBee 受信データ処理 */
		xbeeRxData = xbee_rx_call(&xbee_result);
		switch(xbee_result.MODE){
			case 0x00:
				break;
			case MODE_UAR2:
				index = indexZdoDevice(xbee_result.FROM, deviceIeee, numOfDevice);
				if(
					checkZclCmp(xbee_result.ZCL,0,0,0x0013,0x0000) == 0 &&
					bytecmp(xbee_result.FROM, zbBroadIeee, 8) == 1	// zbBroadIeeeと不一致の時
				){
					/* タップのコミッショニングボタンの処理 */
					i = paringZdoDevice(xbee_result.FROM,deviceIeee, numOfDevice);
					if(i == numOfDevice)numOfDevice++;
					if(i >= 0) deviceDataFlag[i] = 0;
				}else if(checkZclCmp(xbee_result.ZCL,0,0,0x8000,0x0000) == 0){
					if(index >= 0 ) deviceDataFlag[index] = 0;
					else fprintf(stderr,"ERROR:Data from Unregistered Device\n");
				}else if(index >= 0 && checkZclCmp(xbee_result.ZCL,0x14,0x14,0xFD0C,0x0104) == 0){
					if(bytecmp(xbee_result.DATA, zbAplHeaderPow, 7) == 0){
						/* タップからの消費電力[W]情報の処理 */
						deviceDataPow[index] = zbByteFloat(&xbee_result.DATA[7]) * TAP_POWER_ADJ;
						if(deviceDataFlag[index] < 0) deviceDataFlag[index] = 0;
						printDate();
						printf(
							"Recieved from Tap %d Pow=%.0f[W]\n",
							index + 1,
							deviceDataPow[index]
						);
					}else if(bytecmp(xbee_result.DATA, zbAplHeaderSum, 7) == 0){
						/* タップからの消費電力量[Wh]情報の処理 */
						if(deviceDataFlag[index] <= 0){
							deviceDataFlag[index] = 1;
							deviceDataSum[index] = zbByteUint(&xbee_result.DATA[7],6) * TAP_SUM_ADJ;
							printDate();
							printf(
								"Recieved from Tap %d PowSum=%.0f[Wh]\n",
								index + 1,
								deviceDataSum[index]
							);
							saveTapData(xbee_result.FROM, deviceDataSum[index], deviceDataPow[index], deviceDataTime[index]);
						}else fprintf(stderr,"ERROR:Duplication Packets Input (Device=%d)\n",index + 1);
					}else if(bytecmp(xbee_result.DATA, zbAplHeaderTime, 7) == 0){
						/* タップからの測定時間[Sec]情報の処理 */
						if(deviceDataFlag[index] < 0) deviceDataFlag[index] = 0;
						printDate();
						deviceDataTime[index] = zbByteUL(&xbee_result.DATA[7],4);
						printf(
							"Recieved from Tap %d Time=%lu[sec]\n",
							index + 1,
							deviceDataTime[index]
						);
					}else if(bytecmp(xbee_result.DATA, zbAplHeaderTemp, 7) == 0){
						/* タップからの温度[？]情報の処理 */
						if(deviceDataFlag[index] < 0) deviceDataFlag[index] = 0;
						printDate();
						printf(
							"Recieved from Tap %d Temp=%.0f\n",
							index + 1,
							zbByteFloat(&xbee_result.DATA[7])
						);
					}else{
						fprintf(stderr,"ERROR:Recieved Unknown Format (Device=%d)\n",index + 1);
						printUAR2(&xbee_result, xbeeRxData );
						printf("\n");
					}
				}else{
					printUAR2(&xbee_result, xbeeRxData );
					printf("\n");
				}
				break;
			case MODE_MODM:
				printMODE_MODM(xbee_result.STATUS);
				break;
			default:
				printUNKNOWN(xbeeRxData, xbee_result.STATUS);
				break;
		}
		
		/* ユーザインタフェース（キーボード入力） */
		if( kbhit() ){
			keyboardCommand = getchar();
			printf(" -> Accepted\n");
			switch( keyboardCommand ){
				//	未使用　：abdegiklmnruvwy0123456789
				//	予約済み：cfhjopqstxz						 2014/8/12 Yoshi
				case 'X':
					printDateSt(time_st); printf("Restore to XBee mode\n");
					xbeeMode();	// Wataru
				case 'Q':
				case 'Z':
					printDateSt(time_st); printf("Bye!\n");
					mainLoopFlag = 0;
					break;
				case 'j': case 'J':
					paringJoinEnable();
					joinEnable = 1;
					break;
				case 'p':
					printDateSt(time_st); printf("Get Power for %d Taps\n",numOfDevice);
					for(index = 0; index < numOfDevice; index++) sendReadPower(deviceIeee[index]);
					break;
				case 's':
					printDateSt(time_st); printf("Get PowSum for %d Taps\n",numOfDevice);
					for(index = 0; index < numOfDevice; index++) sendReadPowerSummation(deviceIeee[index]);
					break;
				case 't':
					printDateSt(time_st); printf("Get PowTime for %d Taps\n",numOfDevice);
					for(index = 0; index < numOfDevice; index++) sendReadSummationTime(deviceIeee[index]);
					break;
				case 'o':
					printDateSt(time_st); printf("Get Optional for %d Taps\n",numOfDevice);
					for(index = 0; index < numOfDevice; index++) sendReadPowerTemprature(deviceIeee[index]);
					break;
				case 'f':
					printDateSt(time_st); printf("Reset Flags for %d Taps\n",numOfDevice);
					for(index = 0; index < numOfDevice; index++) deviceDataFlag[index] = -1;
					break;
				case 'c':
					compressData(dateStringBuffer, deviceIeee, numOfDevice);
					break;
				case 'C':
					compressDataAll(deviceIeee, numOfDevice);
					break;
				default:
					printUiHelp();
					break;
			}
		}
	}
	return 0;
}

/* その他の雑談 */
//	関数名、変数名はコメントを無くしても分かるように変更しました。（Yoshi）
//	ウィンドウ幅80文字までとなるよう複数行に分割しました。（Yoshi）
//	なるべくYoshi様の初稿ソースに合わせるようにしますが、DIFFをかけたときや
//	マージの時にあまりにも変更箇所が多すぎて、変更点がすぐに分からなくなります。
//	効率よく進めたいので、書き方の違いなどの修正は控えましょう。(Wataru)
//	私の方で原本を管理し、リリース前に管理を国野様に委譲します。（Yoshi）
//	2014/8/15版からは原本管理を私の方で担います。（Wataru）

//	YoshiYoshiは吉(よし)○○吉(きち)をあえてそう呼ばれているのでしょうか？(Wataru)
//	YeahYeah by YoshiYoshi futuring YoshiKichi.

//	今回の共同作品は（私＝Wataruにとって）初めての試みでした。
//	当初、共同で製作すると半分の期間で製作できるように思ったのですが、
//	実際には一人で行うよりも2倍ほどの期間がかかったように感じます。
//	この原因は協業のやり方にあったものと思っています。
//	ソースにコメントを書いてDIFFをとる方法にしてからは、効率は随分と
//	良くなりました。
//	今回の試みで共同製作を行う方法について、少し学ぶことが出来ました。（Wataru）

//	コンパイル時の最適化オプションについて
//	PC用のサンプルアプリのコンパイル時は全警告を有効にするオプション-Wallを
//	付与してソフト製作を行っております。
//	少なくとも、Cygwin 1.7.17でインストールしたgccでは、これまで-Wallで
//	xbee.cに警告が出るようなことはありませんでした。
//	しかし、最適化オプション-O1を指定すると警告が多発することが発覚しました。
//	今回から-O1を指定することとし、本アプリと同時にリリースするライブラリに
//	ついては主要関数を何度もアクセスする試験専用アプリでの1週間の動作耐久試験
//	を行いたいと思います。8月末リリース予定です。（Wataru 2014/8/24）

//	試験の分担
//		・XBeeライブラリ側テスト 責任者＝国野様
//			- PC用の全サンプルアプリのコンパイル試験
//			- PC用の主要アプリでの実動作試験（手順書なし、一般機能を巡回）
//			- 主要関数を何度もアクセスする試験専用アプリでの1週間の動作試験
//		・タップアプリ側テスト 責任者＝Yoshi
//			- 単体試験：ダミースタブ使用。各関数の呼び出し試験
//			- 結合試験：試作版XBeeライブラリ使用。各関数の呼び出し試験
//			- システム試験：β版ライブラリ使用。全機能の巡回試験
//			- 静的コード解析：未定＜追記＞

//	各試験時のシステム数とタップ台数
//		・XBeeライブラリ側テスト　1式×タップ1台　　責任者＝国野
//		・公開アプリテスト　　　　1式×タップ4台　　責任者＝Yoshi様
//		・公開後の継続動作　　　　1式×タップ1台　　責任者＝国野
//		・販売アプリテスト　　　　1式×タップ8台　　責任者＝Yoshi様
//		・販売後のテスト　　　　　2式×タップ4台　　責任者＝Yoshi様
//		タップ8台の確保は完了されたでしょうか？

//	GCCバージョンについて
//	バージョン3.4.4を用いていましたが、Cygwinがデフォルトでインストールする
//	GCCのバージョンが4.7となった関係上、XBeeライブラリについても対応したいと
//	思います。
//	8月末までにXBeeライブラリの評価を完了したいと思いますので、商品版はGCC4
//	でコンパイルしたものを使用してもらえないでしょうか？（Wataru）

